/**
 * \file
 * \brief Functions for communicating with SFPs
 */
#ifndef SFP_H_5D340520BDCF0C0AFC6F51B0FE7E8948
#define SFP_H_5D340520BDCF0C0AFC6F51B0FE7E8948

typedef struct exanic_sfp_info
{
    char        vendor_name[17];
    char        vendor_pn[17];
    char        vendor_rev[5];
    char        vendor_sn[17];
    char        date_code[9];
    int         wavelength;
    int         bit_rate;
} exanic_sfp_info_t;

int exanic_get_sfp_info(exanic_t *exanic, int port_number,
                        exanic_sfp_info_t *info);

typedef struct exanic_diag_info
{
    float       temp;       /* degrees C */
    float       rx_power;   /* mW */
    float       tx_power;   /* mW */
} exanic_sfp_diag_info_t;

int exanic_get_sfp_diag_info(exanic_t *exanic, int port_number,
                             exanic_sfp_diag_info_t *info);

#endif /* SFP_H_5D340520BDCF0C0AFC6F51B0FE7E8948 */
